//+------------------------------------------------------------------+
//|                                                       July20.mq4 |
//+------------------------------------------------------------------+

extern double RiskPercentage = 10;
extern int AmountOfSymbols = 1;
extern double StopLoss = 100;
extern double TrailingStop = 200;
extern int slippage = 4;

int start()
  {
    int cnt, ticket, total, abc;
    if(Bars<10)
     {
      Print("bars less than 10");
      return(0);  
     }
//+------------------------------------------------------------------+
   double ts = TrailingStop;
   double sl = StopLoss;
   int StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if (ts<StopLevel) ts = StopLevel;
   if (sl<StopLevel) sl = StopLevel;
//+------------------------------------------------------------------+
   double margin = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   double minLot = MarketInfo(Symbol(), MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   double step =   MarketInfo(Symbol(), MODE_LOTSTEP);
   double account = AccountFreeMargin();
   double percentage = account*RiskPercentage/100;
   double Lots = MathRound(percentage/margin/step)*step;
   if(Lots < minLot)
   {
      Lots = minLot;
   }
   if(Lots > maxLot)
   {
      Lots = maxLot;
   }
//+------------------------------------------------------------------+
   int buys=0,sells=0;
   total=OrdersTotal();
   for(int a=0;a<=OrdersTotal();a++)
     {
      if(OrderSelect(a,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
        }
//+------------------------------------------------------------------+
      if(total<1 || (buys == 0 && sells == 1 && total<=(2*AmountOfSymbols)) || (buys == 0 && sells == 0 && total<=(2*AmountOfSymbols)))
     {
      if((0.25*High[1]+0.25*Open[1]+0.25*Low[1]+0.25*Close[1])<Open[0])
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,0,0,"",0,0,Green);
        if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)==true)
             {
               if(OrderStopLoss()==0)
                {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Bid-sl*Point,OrderTakeProfit(),0,Green);
                 return(0);
                  }
                   }
                    }
          return(0); 
        }
       return(0);
     }
//+------------------------------------------------------------------+
      if(total<1 || (buys == 1 && sells == 0 && total<=(2*AmountOfSymbols)) || (buys == 0 && sells == 0 && total<=(2*AmountOfSymbols))) 
     {
      if((0.25*High[1]+0.25*Open[1]+0.25*Low[1]+0.25*Close[1])>Open[0])
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,0,0,"",0,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)==true)
             {
               if(OrderStopLoss()==0)
                {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Ask+sl*Point,OrderTakeProfit(),0,Red);
                 return(0);
                   }
                    }
                     }
           return(0); 
        }
     return(0);
     }

//+------------------------------------------------------------------+
   for(abc=0;abc<total;abc++)
     {
      OrderSelect(abc, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)
           {if(OrderStopLoss()==0)
            {OrderModify(OrderTicket(),OrderOpenPrice(),Bid-sl*Point,OrderTakeProfit(),0,Green);
            if(OrderStopLoss()==0) Print("Error modify BUY order : ",GetLastError());
              return(0);
            }
           }
          }
         else 
           {if(OrderSymbol()==Symbol())
            {
             if(OrderType()==OP_SELL)
              {if(OrderStopLoss()==0)
               {OrderModify(OrderTicket(),OrderOpenPrice(),Ask+sl*Point,OrderTakeProfit(),0,Red);
               if(OrderStopLoss()==0) Print("Error modify SELL order : ",GetLastError());
                return(0);
                }
               }
              }
             }
              return(0);
            }

//+------------------------------------------------------------------+

   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && 
         OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)
           {
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*ts)
                 {
                  if(OrderStopLoss()<Bid-Point*ts)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*ts,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else 
           {
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*ts))
                 {
                  if((OrderStopLoss()>(Ask+Point*ts)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*ts,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+